// CPage2.cpp : implementation file
//

#include "stdafx.h"
#include "VSSDisconnector.h"
#include "Page2.h"

#include "Page1.h"


// CPage2 dialog
IMPLEMENT_DYNAMIC(CPage2, CPropertyPage)
CPage2::CPage2()
	: CPropertyPage(CPage2::IDD)
{
}

CPage2::~CPage2()
{
}

void CPage2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_lstFile);
	DDX_Control(pDX, IDC_EDIT1, m_edtPath);
}


BEGIN_MESSAGE_MAP(CPage2, CPropertyPage)
	ON_MESSAGE(WMU_DIE_SEARCH_THREAD, OnDieSearchThread)
END_MESSAGE_MAP()

BOOL CPage2::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_pSearchThread = NULL;

	m_lstFile.SetExtendedStyle( LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT );
	m_lstFile.InsertColumn( 0, _T("ε"), LVCFMT_LEFT, 50 );
	m_lstFile.InsertColumn( 1, _T("̸"), LVCFMT_LEFT, 120 );
	m_lstFile.InsertColumn( 2, _T(""), LVCFMT_LEFT, 250 );
	m_lstFile.InsertColumn( 3, _T("ȭ"), LVCFMT_LEFT, 50 );

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CPage2::OnSetActive()
{
	// Sheet  Ӽ 
	//m_psp.dwFlags |= PSP_HASHELP;
	CPropertySheet* psheet = (CPropertySheet*) GetParent();
	psheet->SetWizardButtons(PSWIZB_BACK);

	// Ʈ 
	m_lstFile.DeleteAllItems();

	// ˻
	CPage1* pPage1 = static_cast< CPage1* >( psheet->GetPage(0) );
	CString strPath;
	pPage1->m_edtPath.GetWindowText(strPath);

	//  
	TrdInfoSearch* pInfo = new TrdInfoSearch;
	pInfo->m_pMsgWnd = this;
	pInfo->m_strPath = strPath;

	m_pSearchThread = AfxBeginThread(ThreadSearchFile, (LPVOID)pInfo, THREAD_PRIORITY_NORMAL);

	return CPropertyPage::OnSetActive();
}

void CPage2::AddFileToList( CString strName, CString strPath, CString strChange )
{
	int nItemCount = m_lstFile.GetItemCount();
	CString strTmp;
	strTmp.Format("%d", nItemCount+1 );
	m_lstFile.InsertItem( nItemCount, strTmp );
	m_lstFile.SetItemText( nItemCount, 1, strName );
	m_lstFile.SetItemText( nItemCount, 2, strPath );
	m_lstFile.SetItemText( nItemCount, 3, strChange );
}

BOOL CPage2::OnQueryCancel()
{
	if (m_pSearchThread)
	{
		m_pSearchThread->SuspendThread();
		delete m_pSearchThread;
		m_pSearchThread = NULL;
		m_edtPath.SetWindowText("");
		return FALSE;
	}

	return CPropertyPage::OnQueryCancel();
}

LRESULT CPage2::OnDieSearchThread(WPARAM wp, LPARAM lp)
{
	m_edtPath.SetWindowText( "Ϸ" );
	m_pSearchThread = NULL;

	CPropertySheet* psheet = (CPropertySheet*) GetParent();
	psheet->SetWizardButtons(PSWIZB_BACK | PSWIZB_NEXT);

	return 0;
}

/////////////////////////////////////////////////////////////////////////
// TODO: ã   Լ
UINT ThreadSearchFile( LPVOID pParam )
{
	TrdInfoSearch* pInfo = (TrdInfoSearch*)pParam;

	::SetCurrentDirectory( pInfo->m_strPath );
	pInfo->m_pMsgWnd->m_edtPath.SetWindowText( pInfo->m_strPath );
	SearchFolder( pInfo->m_pMsgWnd );

	pInfo->m_pMsgWnd->SendMessage(WMU_DIE_SEARCH_THREAD);
	delete pInfo;

	return 0;
}

void SearchFolder( CPage2* pLstWnd )
{
	char szCurPath[MAX_PATH];
	memset(szCurPath, 0, sizeof(char)*MAX_PATH);
	GetCurrentDirectory(MAX_PATH, szCurPath);
	CString strCurPath = szCurPath;
	pLstWnd->m_edtPath.SetWindowText( strCurPath );

	WIN32_FIND_DATA fd;
	HANDLE hFind = ::FindFirstFile( _T("*.*"), &fd );
	if( hFind != INVALID_HANDLE_VALUE )
	{
		do
		{
			if( fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
			{
				// 
				CString strName = fd.cFileName;
				if( strName != "." && strName != ".." )
				{
					CString strNewPath = strCurPath + "\\" + strName;
					TRACE("%s\n", strNewPath);
					::SetCurrentDirectory( strName );
					SearchFolder( pLstWnd );
					::SetCurrentDirectory( _T("..") );
				}
			}
			else
			{
				// 
				CString strName = fd.cFileName;
				CString strNewPath = strCurPath + "\\" + strName;
				TRACE("%s\n", strNewPath);

				if( strName.Right(4) == ".scc" )
					pLstWnd->AddFileToList( strName, strCurPath, "" );
				else if( strName.Right(4) == ".sln" )
					pLstWnd->AddFileToList( strName, strCurPath, "" );
				else if( strName.Right(7) == ".vcproj" )
					pLstWnd->AddFileToList( strName, strCurPath, "" );
				//else if( strName.Right(4) == ".dsw" )
				//	pLstWnd->AddFileToList( strName, strCurPath, "" );
			}

		}while( ::FindNextFile( hFind, &fd ) );
		::FindClose( hFind );
	}
}

