// Page3.cpp : implementation file
//

#include "stdafx.h"
#include "VSSDisconnector.h"
#include "Page3.h"

// CPage3 dialog

IMPLEMENT_DYNAMIC(CPage3, CPropertyPage)
CPage3::CPage3()
	: CPropertyPage(CPage3::IDD)
{
}

CPage3::~CPage3()
{
}

void CPage3::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT2, m_EdtFolderPath);
	DDX_Control(pDX, IDC_EDIT1, m_EdtFileName);
	DDX_Control(pDX, IDC_PROGRESS1, m_progress);
	DDX_Control(pDX, IDC_EDIT3, m_EdtProcess);
	DDX_Control(pDX, IDC_BUTTON1, m_btnViewResult);
}


BEGIN_MESSAGE_MAP(CPage3, CPropertyPage)
	ON_MESSAGE(WMU_DIE_PROCESS_THREAD, OnDieProcessThread)
	ON_MESSAGE(WMU_KILL_PROCESS_THREAD, OnKillProcessThread)
	ON_MESSAGE(WMU_MSG_PROCESS_THREAD, OnMsgProcessThread)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
END_MESSAGE_MAP()


// CPage3 message handlers
BOOL CPage3::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_pProcessThread = NULL;
	m_pThreadInfo = NULL;

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CPage3::OnSetActive()
{
	m_btnViewResult.EnableWindow( FALSE );

	CPropertySheet* psheet = (CPropertySheet*) GetParent();
	psheet->SetWizardButtons(PSWIZB_BACK);

	// Ʈ  
	CPage1* pPage1 = static_cast< CPage1* >( psheet->GetPage(0) );
	CString strPath;
	pPage1->m_edtPath.GetWindowText(strPath);
	m_EdtFolderPath.SetWindowText( strPath );

	// óƮ 
	CPage2* pPage2 = static_cast< CPage2* >( psheet->GetPage(1) );
	m_nListCnt = pPage2->m_lstFile.GetItemCount();
	m_progress.SetRange(0, m_nListCnt);
	CString strCnt;
	strCnt.Format("%d/%d",0,m_nListCnt);
	m_EdtProcess.SetWindowText(strCnt);

	//  
	m_pThreadInfo = new TrdInfoProcess;
	m_pThreadInfo->m_bThread = TRUE;
	m_pThreadInfo->m_pMsgWnd = this;
	m_pThreadInfo->m_pList = &(pPage2->m_lstFile);

	m_pProcessThread = AfxBeginThread(ThreadProcess, (LPVOID)m_pThreadInfo, THREAD_PRIORITY_NORMAL);

	return CPropertyPage::OnSetActive();
}

BOOL CPage3::OnKillActive()
{
	if(m_pThreadInfo)
	{
		delete m_pThreadInfo;
		m_pThreadInfo = NULL;
	}

	return CPropertyPage::OnKillActive();
}

BOOL CPage3::OnQueryCancel()
{
	if (m_pThreadInfo != NULL)
	{
		if( m_pThreadInfo->m_bThread == TRUE )
		{
			m_pThreadInfo->m_bThread = FALSE;
			return FALSE;
		}
	}

	return CPropertyPage::OnQueryCancel();
}

LRESULT CPage3::OnDieProcessThread(WPARAM wp, LPARAM lp)
{
	m_progress.SetPos(m_nListCnt);
	//m_EdtProcess.SetWindowText( "Ϸ" );
	m_pProcessThread = NULL;
	m_pThreadInfo->m_bThread = FALSE;

	CPropertySheet* psheet = (CPropertySheet*) GetParent();
	psheet->SetWizardButtons(PSWIZB_BACK | PSWIZB_FINISH);
	m_btnViewResult.EnableWindow( TRUE );

	return 0;
}

LRESULT CPage3::OnKillProcessThread(WPARAM wp, LPARAM lp)
{
	m_EdtProcess.SetWindowText( "" );
	m_pProcessThread = NULL;
	m_pThreadInfo->m_bThread = FALSE;

	CPropertySheet* psheet = (CPropertySheet*) GetParent();
	psheet->SetWizardButtons(PSWIZB_BACK | PSWIZB_DISABLEDFINISH);
	m_btnViewResult.EnableWindow( FALSE );

	return 0;
}

LRESULT CPage3::OnMsgProcessThread(WPARAM wp, LPARAM lp)
{
	int nProIdx = (int)wp;

	m_progress.SetPos(nProIdx);
	
	CString strCnt;
	strCnt.Format("%d/%d",nProIdx+1,m_nListCnt);
	m_EdtProcess.SetWindowText(strCnt);

	CString strTmp = m_pThreadInfo->m_pList->GetItemText(nProIdx, 1 );
	m_EdtFileName.SetWindowText( strTmp );

	return 0;
}

void CPage3::OnBnClickedButton1()
{
	// TODO :  ư Ŭ
	
}
//////////////////////////////////////////////////////
// TODO : ThreadProcess
UINT ThreadProcess( LPVOID pParam )
{
	TrdInfoProcess* pInfo = (TrdInfoProcess*)pParam;
	CPage3* pMsgWnd = pInfo->m_pMsgWnd;
	CListCtrl* plist = pInfo->m_pList;

	int nProIdx = 0;

	while( true )
	{
		if( pInfo->m_bThread == FALSE )
		{
			pMsgWnd->SendMessage(WMU_KILL_PROCESS_THREAD);
			return 0;
		}
		else if( nProIdx >= plist->GetItemCount() )
		{
			break;
		}

		CString strRes, strOriginal;
		CString strName = plist->GetItemText( nProIdx, 1 );
		CString strPath = plist->GetItemText( nProIdx, 2 );
		CString strChange = plist->GetItemText( nProIdx, 3 );
		CString strFilePath = strPath+"\\"+strName;

		if( strChange == "" )
		{
			strRes = DeleteDestFile( strFilePath );
			pInfo->m_strArrDelRes.Add( strRes );
		}
		else if( strChange == "")
		{
			strRes = ModifyDestFile( strFilePath, strOriginal );
			pInfo->m_strArrModRes.Add( strRes );
			pInfo->m_strArrModOri.Add( strOriginal );
		}

		pMsgWnd->SendMessage(WMU_MSG_PROCESS_THREAD, (WPARAM)nProIdx);
		nProIdx++;
	}

	pMsgWnd->SendMessage(WMU_DIE_PROCESS_THREAD);

	return 0;
}

CString DeleteDestFile( CString strFilePath )
{
	// ϼӼ (Read Only   ȵ)
	SetFileAttributes(strFilePath,  FILE_ATTRIBUTE_NORMAL); 

	CString strRes;
	BOOL bResult = DeleteFile( strFilePath );
	if( bResult != 0 )
	{
		strRes.Format("[%s]   ", (LPCSTR)strFilePath );
	}
	else
	{
		int nTmp = GetLastError();
		strRes.Format("[%s]    (%d)", (LPCSTR)strFilePath, nTmp );
	}
	return strRes;
}

CString	ModifyDestFile( CString strFilePath, CString& strOriginal )
{
	CString strRes;

	// Ͽ
	HANDLE hFile = CreateFile( strFilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ); 
	if( hFile == INVALID_HANDLE_VALUE )
	{
		strRes.Format("[%s]   ", (LPCSTR)strFilePath );
		return strRes;
	}

	int nFilesize = GetFileSize( hFile, NULL );
	
	// б
	char* szBuffer = new char[ nFilesize+1 ];
	ZeroMemory( szBuffer, nFilesize+1 );
	DWORD dwReadSize = 0;
	if( !(ReadFile( hFile, (LPVOID)szBuffer, nFilesize, &dwReadSize, NULL )) )
	{
		CloseHandle( hFile );
		delete [] szBuffer;

		strRes.Format("[%s]  ϱ ", (LPCSTR)strFilePath );
		return strRes;
	}
	CloseHandle( hFile );
	strOriginal.Format("%s", szBuffer );
	int nTmp = strOriginal.GetLength();
	delete [] szBuffer;

	//  Ȯڿ  ҽ  ׸ 
	if( strFilePath.Right(4) == ".sln" )
	{
		int nPos1 = strOriginal.Find( "GlobalSection(SourceCodeControl)", 0 );
		if( nPos1 == -1)
		{
			strRes.Format("[%s]  Ȯ ", (LPCSTR)strFilePath );
			return strRes;
		}

		int nPos2 = strOriginal.Find( "EndGlobalSection", nPos1 );
		if( nPos2 == -1 )
		{
			strRes.Format("[%s]  Ȯ ", (LPCSTR)strFilePath );
			return strRes;
		}

		CString strPrev = strOriginal.Left(nPos1);
		CString strNext = strOriginal.Right(strOriginal.GetLength() - nPos2);
		strNext.TrimLeft();
		strRes = strPrev + strNext;
	}
	else if( strFilePath.Right(7) == ".vcproj" )
	{
		int nPos = 0, nPosTmp = 0;
		CString strPrev, strNext;
		strRes = strOriginal;

		nPos = strRes.Find( "SccProjectName", 0 );
		if( nPos == -1)
		{
			strRes.Format("[%s]  Ȯ ", (LPCSTR)strFilePath );
			return strRes;
		}

		nPosTmp = strRes.Find( "\n", nPos );
		if( nPosTmp == -1 )
		{
			strRes.Format("[%s]  Ȯ ", (LPCSTR)strFilePath );
			return strRes;
		}

		strPrev = strRes.Left(nPos);
		strNext = strRes.Right( strRes.GetLength() - (nPosTmp) );
		strNext.TrimLeft();
		strRes = strPrev + strNext;

		nPos = strRes.Find( "SccLocalPath", 0 );
		if( nPos == -1 )
		{
			strRes.Format("[%s]  Ȯ ", (LPCSTR)strFilePath );
			return strRes;
		}

		nPosTmp = strRes.Find( "\n", nPos );
		if( nPosTmp == -1 )
		{
			strRes.Format("[%s]  Ȯ ", (LPCSTR)strFilePath );
			return strRes;
		}

		strPrev = strRes.Left(nPos);
		strNext = strRes.Right(strRes.GetLength() - (nPosTmp));
		strNext.TrimLeft();
		strRes = strPrev + strNext;
	}
	//else if( strFilePath.Right(4) == ".dsw")
	//{
	//}


	// ϻ
	DWORD dwFileAttr = GetFileAttributes( strFilePath );
	SetFileAttributes(strFilePath,  FILE_ATTRIBUTE_NORMAL); 
	hFile = CreateFile( strFilePath, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL ); 
	if( hFile == INVALID_HANDLE_VALUE )
	{
		strRes.Format("[%s]   ", (LPCSTR)strFilePath );
		int nTmp = GetLastError();
		return strRes;
	}

	DWORD dwTmp;
	WriteFile( hFile, strRes.GetBuffer( strRes.GetLength() ), strRes.GetLength() , &dwTmp, NULL );
	CloseHandle( hFile );
	SetFileAttributes(strFilePath, dwFileAttr); 

	return strRes;
}
